import vrml.Event;
import vrml.field.SFBool;
import vrml.field.SFFloat;
import vrml.field.SFNode;
import vrml.field.SFRotation;
import vrml.field.SFVec3f;
import vrml.node.Node;
import vrml.node.Script;

public class shadow extends Script {
   private Node light;
   private Node object;
   private Node shadow;
   private boolean shadow_length;
   private boolean shadow_length_and_depth;
   private SFVec3f lightTranslation;
   private SFVec3f objectTranslation;
   private SFVec3f objectScale;
   private SFRotation shadowRotation;
   private SFVec3f shadowScale;
   private SFFloat shadowTransparency;
   private float[] l_trans = new float[3];
   private float[] o_trans = new float[3];
   private float[] o_scale = new float[3];
   private float[] s_rot = new float[]{0.0F, 1.0F, 0.0F, 0.0F};
   private float[] s_scale = new float[]{1.0F, 1.0F, 1.0F};
   private float s_transparency;
   private float[] vec = new float[3];
   // $FF: renamed from: d float
   private float field_0;

   public void initialize() {
      this.light = (Node)((SFNode)((Script)this).getField("light")).getValue();
      this.object = (Node)((SFNode)((Script)this).getField("object")).getValue();
      this.shadow = (Node)((SFNode)((Script)this).getField("shadow")).getValue();
      this.shadow_length = ((SFBool)((Script)this).getField("shadow_length")).getValue();
      this.shadow_length_and_depth = ((SFBool)((Script)this).getField("shadow_length_and_depth")).getValue();
      this.lightTranslation = (SFVec3f)this.light.getExposedField("translation");
      this.objectTranslation = (SFVec3f)this.object.getExposedField("translation");
      this.objectScale = (SFVec3f)this.object.getExposedField("scale");
      this.shadowRotation = (SFRotation)this.shadow.getExposedField("rotation");
      this.shadowScale = (SFVec3f)this.shadow.getExposedField("scale");
      this.shadowTransparency = (SFFloat)this.shadow.getExposedField("transparency");
   }

   public void processEvent(Event var1) {
      if (var1.getName().equals("interval")) {
         System.out.println(this.shadowTransparency);
         this.lightTranslation.getValue(this.l_trans);
         this.objectTranslation.getValue(this.o_trans);
         this.objectScale.getValue(this.o_scale);
         this.vec[0] = this.o_trans[0] - this.l_trans[0];
         this.vec[2] = this.o_trans[2] - this.l_trans[2];
         this.field_0 = (float)Math.sqrt((double)(this.vec[0] * this.vec[0] + this.vec[2] * this.vec[2]));
         float[] var10000 = this.vec;
         var10000[0] /= this.field_0;
         var10000 = this.vec;
         var10000[2] /= this.field_0;
         if ((double)this.vec[0] < (double)0.0F) {
            this.s_rot[3] = (float)Math.acos((double)(-this.vec[2]));
         } else {
            this.s_rot[3] = -((float)Math.acos((double)(-this.vec[2])));
         }

         this.shadowRotation.setValue(this.s_rot);
         if (this.shadow_length || this.shadow_length_and_depth) {
            if (this.l_trans[1] < this.o_scale[1]) {
               this.s_scale[2] = 0.0F;
            } else {
               this.s_scale[2] = this.field_0 / (this.l_trans[1] - this.o_scale[1]);
            }

            this.shadowScale.setValue(this.s_scale);
         }

         if (this.shadow_length_and_depth) {
            if (this.s_scale[2] < 1.0F) {
               this.s_transparency = 0.0F;
            } else {
               this.s_transparency = 1.0F / this.s_scale[2];
               this.s_transparency = 1.0F - this.s_transparency;
            }

            this.shadowTransparency.setValue(this.s_transparency);
         }
      }

   }
}
